## ros-one-apriltag-ros 3.2.1-23noble.20251023.0444

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(apriltag_ros)

set(CMAKE_CXX_STANDARD 17)

find_package(catkin REQUIRED COMPONENTS
  cmake_modules
  cv_bridge
  geometry_msgs
  image_geometry
  image_transport
  message_generation
  nodelet
  pluginlib
  roscpp
  sensor_msgs
  std_msgs
  tf
)

find_package(Eigen3 REQUIRED)
find_package(OpenCV REQUIRED)
find_package(apriltag REQUIRED)

# Set the build type.  Options are:
#  Coverage       : w/ debug symbols, w/o optimization, w/ code-coverage
#  Debug          : w/ debug symbols, w/o optimization
#  Release        : w/o debug symbols, w/ optimization
#  RelWithDebInfo : w/ debug symbols, w/ optimization
#  MinSizeRel     : w/o debug symbols, w/ optimization, stripped binaries
# We default to 'Release' if none was specified
IF(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  MESSAGE(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the build type" FORCE)
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Coverage" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF()

add_compile_options("-O3" "-funsafe-loop-optimizations" "-fsee" "-funroll-loops" "-fno-math-errno" "-funsafe-math-optimizations" "-ffinite-math-only" "-fno-signed-zeros")

# Note: These options have been turned off to allow for binary releases - 
# in local builds, they can be reactivated to achieve higher performance.
# if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "x86_64" OR "x86_32")
#   message("enabling msse2 for x86_64 or x86_32 architecture")
#   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native -msse2 ")
# endif()
# if("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "arm")
#   message("enabling -mfpu=neon -mfloat-abi=softfp for ARM architecture")
#   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=armv7-a -mcpu=cortex-a9 -mfpu=neon -mtune=cortex-a9 -mvectorize-with-neon-quad -ffast-math ")
# endif()

add_message_files(
  FILES
  AprilTagDetection.msg
  AprilTagDetectionArray.msg
)

add_service_files(
  FILES
  AnalyzeSingleImage.srv
)

generate_messages(
  DEPENDENCIES
  geometry_msgs
  sensor_msgs
  std_msgs
)

# Extract the include directories and libraries from apriltag::apriltag as catkin_package() does not support modern cmake.
get_target_property(apriltag_INCLUDE_DIRS apriltag::apriltag INTERFACE_INCLUDE_DIRECTORIES)
get_target_property(apriltag_LIBRARIES apriltag::apriltag INTERFACE_LINK_LIBRARIES)

catkin_package(
  INCLUDE_DIRS
    include
    ${EIGEN3_INCLUDE_DIRS}
  CATKIN_DEPENDS
    cv_bridge
    geometry_msgs
    image_transport
    message_runtime
    nodelet
    pluginlib
    roscpp
    sensor_msgs
    std_msgs
    tf
  DEPENDS
    apriltag
    OpenCV
  LIBRARIES
    ${PROJECT_NAME}_common
    ${PROJECT_NAME}_continuous_detector
    ${PROJECT_NAME}_single_image_detector
)

###########
## Build ##
###########

include_directories(include
  ${catkin_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME}_common src/common_functions.cpp)
add_dependencies(${PROJECT_NAME}_common ${PROJECT_NAME}_generate_messages_cpp)
target_link_libraries(${PROJECT_NAME}_common ${catkin_LIBRARIES} ${OpenCV_LIBRARIES} apriltag::apriltag)

add_library(${PROJECT_NAME}_continuous_detector src/continuous_detector.cpp)
target_link_libraries(${PROJECT_NAME}_continuous_detector ${PROJECT_NAME}_common ${catkin_LIBRARIES})

add_library(${PROJECT_NAME}_single_image_detector src/single_image_detector.cpp)
target_link_libraries(${PROJECT_NAME}_single_image_detector ${PROJECT_NAME}_common ${catkin_LIBRARIES})

add_executable(${PROJECT_NAME}_continuous_node src/${PROJECT_NAME}_continuous_node.cpp)
add_dependencies(${PROJECT_NAME}_continuous_node ${PROJECT_NAME}_generate_messages_cpp)
target_link_libraries(${PROJECT_NAME}_continuous_node ${PROJECT_NAME}_continuous_detector ${catkin_LIBRARIES})

add_executable(${PROJECT_NAME}_single_image_server_node src/${PROJECT_NAME}_single_image_server_node.cpp)
add_dependencies(${PROJECT_NAME}_single_image_server_node ${PROJECT_NAME}_generate_messages_cpp)
target_link_libraries(${PROJECT_NAME}_single_image_server_node ${PROJECT_NAME}_single_image_detector ${catkin_LIBRARIES})

add_executable(${PROJECT_NAME}_single_image_client_node src/${PROJECT_NAME}_single_image_client_node.cpp)
add_dependencies(${PROJECT_NAME}_single_image_client_node ${PROJECT_NAME}_generate_messages_cpp)
target_link_libraries(${PROJECT_NAME}_single_image_client_node ${PROJECT_NAME}_common ${catkin_LIBRARIES})


#############
## Install ##
#############

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(DIRECTORY config launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(FILES nodelet_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(TARGETS
  ${PROJECT_NAME}_common
  ${PROJECT_NAME}_continuous_detector
  ${PROJECT_NAME}_continuous_node
  ${PROJECT_NAME}_single_image_client_node
  ${PROJECT_NAME}_single_image_detector
  ${PROJECT_NAME}_single_image_server_node
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

install(PROGRAMS scripts/analyze_image DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

## ros-one-apriltag-ros 3.2.1-23jammy.20251023.0818

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23jammy.20251023.0818) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Thu, 23 Oct 2025 08:18:45 +0000

ros-one-apriltag-ros (3.2.1-0jammy) jammy; urgency=high

  * Fixed propagation of apriltag and Eigen headers and libraries (#124 <https://github.com/AprilRobotics/apriltag_ros/issues/124>)
  * Drop old C++11 as it breaks with new log4cxx.
  * Contributors: Jochen Sprickerhof, Remo Diethelm, Wolfgang Merkt

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Tue, 05 Apr 2022 00:00:00 -0000

ros-one-apriltag-ros (3.2.0-0jammy) jammy; urgency=high

  * Add transport hint option (#108 <https://github.com/AprilRobotics/apriltag_ros/issues/108>)
  * Move to using the apriltag CMake target (#104 <https://github.com/AprilRobotics/apriltag_ros/issues/104>)
  * Set the tag's parent frame to the camera optical frame (#101 <https://github.com/AprilRobotics/apriltag_ros/issues/101>)
  * Fix bug in K matrix in single_image_client (#103 <https://github.com/AprilRobotics/apriltag_ros/issues/103>)
  * Add configurable max_hamming_distance for the AprilTag Detector (#93 <https://github.com/AprilRobotics/apriltag_ros/issues/93>)
  * Introduce lazy processing for ContinuousDetector (#80 <https://github.com/AprilRobotics/apriltag_ros/issues/80>)
  * Contributors: Akshay Prasad, Amal Nanavati, Christian Rauch, Hongzhuo Liang, Wolfgang Merkt

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Thu, 10 Mar 2022 00:00:00 -0000

ros-one-apriltag-ros (3.1.2-0jammy) jammy; urgency=high

  * Add support for tagCircle21h7, tagCircle49h12 (#69 <https://github.com/AprilRobotics/apriltag_ros/issues/69>)
  * Add support for tagCustom48h12 (#65 <https://github.com/AprilRobotics/apriltag_ros/issues/65>)
  * Contributors: Anthony Biviano, Kyle Saltmarsh, Wolfgang Merkt, kai wu

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Wed, 15 Jul 2020 00:00:00 -0000

ros-one-apriltag-ros (3.1.1-0jammy) jammy; urgency=high

  * Add support for tagStandard41h12 and tagStandard52h13 (#63 <https://github.com/AprilRobotics/apriltag_ros/issues/63>, #59 <https://github.com/AprilRobotics/apriltag_ros/issues/59>).
  * Add gray image input support (#58 <https://github.com/AprilRobotics/apriltag_ros/issues/58>).
  * Contributors: Alexander Reimann, Moritz Zimmermann, Samuel Bachmann, Wolfgang Merkt

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Mon, 07 Oct 2019 00:00:00 -0000

ros-one-apriltag-ros (3.1.0-0jammy) jammy; urgency=high

  * Prepare for release (3.1) and fix catkin_lint errors
  * Upgrade to AprilTag 3, fix installation, and performance improvements (#43 <https://github.com/AprilRobotics/apriltag_ros/issues/43>)
    Upgrade to AprilTag 3, fix installation, and performance improvements
  * Rename package to apriltag_ros
    - Relates to https://github.com/AprilRobotics/apriltag_ros/issues/45
  * Contributors: Wolfgang Merkt

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Sat, 25 May 2019 00:00:00 -0000

ros-one-apriltag-ros (1.0.0-0jammy) jammy; urgency=high



 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Mon, 14 May 2018 00:00:00 -0000

=== debian/control ===
Source: ros-one-apriltag-ros
Section: misc
Priority: optional
Maintainer: Danylo Malyuta <danylo.malyuta@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libopencv-dev, ros-one-apriltag, ros-one-catkin, ros-one-cmake-modules, ros-one-cv-bridge, ros-one-geometry-msgs, ros-one-image-geometry, ros-one-image-transport, ros-one-message-generation, ros-one-nodelet, ros-one-pluginlib, ros-one-roscpp, ros-one-sensor-msgs, ros-one-std-msgs, ros-one-tf
Homepage: http://www.ros.org/wiki/apriltag_ros
Standards-Version: 3.9.2

Package: ros-one-apriltag-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libopencv-dev, ros-one-apriltag, ros-one-cv-bridge, ros-one-geometry-msgs, ros-one-image-geometry, ros-one-image-transport, ros-one-message-runtime, ros-one-nodelet, ros-one-pluginlib, ros-one-roscpp, ros-one-sensor-msgs, ros-one-std-msgs, ros-one-tf
Description: A ROS wrapper of the AprilTag 3 visual fiducial detection algorithm.
 Provides full access to the core AprilTag 3 algorithm's customizations and makes the tag detection image and detected tags' poses available over ROS topics (including tf). The core AprilTag 3 algorithm is extended to allow the detection of tag bundles and a bundle calibration script is provided (bundle detection is more accurate than single tag detection). Continuous (camera image stream) and single image detector nodes are available.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-apriltag-ros//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-apriltag-ros 3.2.1-23jammy.20251207.2118

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23jammy.20251207.2118) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Sun, 07 Dec 2025 21:18:02 +0000

## ros-one-apriltag-ros 3.2.1-23jammy.20260120.2117

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23jammy.20260120.2117) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Tue, 20 Jan 2026 21:17:03 +0000

## ros-one-apriltag-ros 3.2.1-23jammy.20260207.2209

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23jammy.20260207.2209) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Sat, 07 Feb 2026 22:09:21 +0000

## ros-one-apriltag-ros 3.2.1-23jammy.20260301.2104

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23jammy.20260301.2104) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Sun, 01 Mar 2026 21:04:48 +0000

## ros-one-apriltag-ros 3.2.1-23noble.20251023.0444

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23noble.20251023.0444) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Thu, 23 Oct 2025 04:44:26 +0000

ros-one-apriltag-ros (3.2.1-0noble) noble; urgency=high

  * Fixed propagation of apriltag and Eigen headers and libraries (#124 <https://github.com/AprilRobotics/apriltag_ros/issues/124>)
  * Drop old C++11 as it breaks with new log4cxx.
  * Contributors: Jochen Sprickerhof, Remo Diethelm, Wolfgang Merkt

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Tue, 05 Apr 2022 00:00:00 -0000

ros-one-apriltag-ros (3.2.0-0noble) noble; urgency=high

  * Add transport hint option (#108 <https://github.com/AprilRobotics/apriltag_ros/issues/108>)
  * Move to using the apriltag CMake target (#104 <https://github.com/AprilRobotics/apriltag_ros/issues/104>)
  * Set the tag's parent frame to the camera optical frame (#101 <https://github.com/AprilRobotics/apriltag_ros/issues/101>)
  * Fix bug in K matrix in single_image_client (#103 <https://github.com/AprilRobotics/apriltag_ros/issues/103>)
  * Add configurable max_hamming_distance for the AprilTag Detector (#93 <https://github.com/AprilRobotics/apriltag_ros/issues/93>)
  * Introduce lazy processing for ContinuousDetector (#80 <https://github.com/AprilRobotics/apriltag_ros/issues/80>)
  * Contributors: Akshay Prasad, Amal Nanavati, Christian Rauch, Hongzhuo Liang, Wolfgang Merkt

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Thu, 10 Mar 2022 00:00:00 -0000

ros-one-apriltag-ros (3.1.2-0noble) noble; urgency=high

  * Add support for tagCircle21h7, tagCircle49h12 (#69 <https://github.com/AprilRobotics/apriltag_ros/issues/69>)
  * Add support for tagCustom48h12 (#65 <https://github.com/AprilRobotics/apriltag_ros/issues/65>)
  * Contributors: Anthony Biviano, Kyle Saltmarsh, Wolfgang Merkt, kai wu

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Wed, 15 Jul 2020 00:00:00 -0000

ros-one-apriltag-ros (3.1.1-0noble) noble; urgency=high

  * Add support for tagStandard41h12 and tagStandard52h13 (#63 <https://github.com/AprilRobotics/apriltag_ros/issues/63>, #59 <https://github.com/AprilRobotics/apriltag_ros/issues/59>).
  * Add gray image input support (#58 <https://github.com/AprilRobotics/apriltag_ros/issues/58>).
  * Contributors: Alexander Reimann, Moritz Zimmermann, Samuel Bachmann, Wolfgang Merkt

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Mon, 07 Oct 2019 00:00:00 -0000

ros-one-apriltag-ros (3.1.0-0noble) noble; urgency=high

  * Prepare for release (3.1) and fix catkin_lint errors
  * Upgrade to AprilTag 3, fix installation, and performance improvements (#43 <https://github.com/AprilRobotics/apriltag_ros/issues/43>)
    Upgrade to AprilTag 3, fix installation, and performance improvements
  * Rename package to apriltag_ros
    - Relates to https://github.com/AprilRobotics/apriltag_ros/issues/45
  * Contributors: Wolfgang Merkt

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Sat, 25 May 2019 00:00:00 -0000

ros-one-apriltag-ros (1.0.0-0noble) noble; urgency=high



 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Mon, 14 May 2018 00:00:00 -0000

## ros-one-apriltag-ros 3.2.1-23noble.20251208.0819

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23noble.20251208.0819) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Mon, 08 Dec 2025 08:19:23 +0000

## ros-one-apriltag-ros 3.2.1-23noble.20260120.2114

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23noble.20260120.2114) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Tue, 20 Jan 2026 21:14:20 +0000

## ros-one-apriltag-ros 3.2.1-23noble.20260207.2207

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23noble.20260207.2207) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Sat, 07 Feb 2026 22:07:06 +0000

## ros-one-apriltag-ros 3.2.1-23noble.20260302.0748

=== debian/changelog ===
ros-one-apriltag-ros (3.2.1-23noble.20260302.0748) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Danylo Malyuta <danylo.malyuta@gmail.com>  Mon, 02 Mar 2026 07:48:04 +0000
